{%- macro vote(entity, route) -%}
  {% with {
    VOTE_NONE: constant('App\\Entity\\Contracts\\VotableInterface::VOTE_NONE'),
    VOTE_UP: constant('App\\Entity\\Contracts\\VotableInterface::VOTE_UP'),
    VOTE_DOWN: constant('App\\Entity\\Contracts\\VotableInterface::VOTE_DOWN'),
  } %}
    {{- block('vote') -}}
  {% endwith %}
{%- endmacro -%}

{%- block vote -%}
  {%- from '_macros/icon.html.twig' import icon -%}

  {%- set user_choice = is_granted('ROLE_USER') ? entity.userChoice(app.user) : null -%}
  {%- apply spaceless -%}
    <form action="{{ path(route, {id: entity.id}) }}" method="post"
          class="vote
                {{- user_choice == VOTE_UP ? ' vote--user-upvoted' }}
                {{- user_choice == VOTE_DOWN ? ' vote--user-downvoted' }}"
          data-ajax-action="{{ path(route, {id: entity.id, _format: 'json'}) }}"
          data-score="{{ entity.netScore }}"
          data-load-prototype="{{ icon('spinner', 'loading', 'icon--spin icon--no-align')|e }}">

      {# csrf_token starts a session #}
      {% if is_granted('ROLE_USER') %}
        <input type="hidden" name="token" value="{{ csrf_token('vote') }}">
      {% endif %}

      <button type="submit" name="choice" value="{{ user_choice == VOTE_UP ? VOTE_NONE : VOTE_UP }}"
              class="unbuttonize vote__button vote__up"
              title="{{ (user_choice == VOTE_UP ? 'action.retract_upvote' : 'action.upvote')|trans }}">
        <span aria-hidden="true">{{ icon('up', 'up', 'icon--no-align') }}</span>
      </button>

      <span class="vote__net-score">{{ entity.netScore < 0 ? '&minus;' }}{{ entity.netScore|abs }}</span>

      <button type="submit" name="choice" value="{{ user_choice == VOTE_DOWN ? VOTE_NONE : VOTE_UP }}"
              class="unbuttonize vote__button vote__down"
              title="{{ (user_choice == VOTE_DOWN ? 'action.retract_downvote' : 'action.downvote')|trans }}">
        <span aria-hidden="true">{{ icon('down', 'down', 'icon--no-align') }}</span>
      </button>
    </form>
  {%- endapply -%}
{%- endblock -%}
